﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ComponentModel;
using Utils;
using ZWave.CommandClasses;
using ZWave.Security;

namespace ZWave.ZnifferApplication
{
    public class FilterObject : INotifyPropertyChanged
    {
        public FilterObject()
        {
            ExpectedFramesCount = 1;
        }

        private int mFilteredCount;
        public int FilteredCount
        {
            get { return mFilteredCount; }
            set
            {
                mFilteredCount = value;
                //RaisePropertyChanged("FilteredCount");
            }
        }

        public int FramesCount { get; set; }
        public int ExpectedFramesCount { get; set; }

        private DateTime? mFilterDate1;
        public DateTime? FilterDate1
        {
            get { return mFilterDate1; }
            set
            {
                mFilterDate1 = value;
                RaisePropertyChanged("FilterDate1");
                RaisePropertyChanged("HasFilter");
            }
        }

        private DateTime? mFilterDate2;
        public DateTime? FilterDate2
        {
            get { return mFilterDate2; }
            set
            {
                mFilterDate2 = value;
                RaisePropertyChanged("FilterDate2");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayDate = true;
        public bool IsDisplayDate
        {
            get { return mIsDisplayDate; }
            set
            {
                mIsDisplayDate = value;
                RaisePropertyChanged("IsDisplayDate");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool? mFilterIsLow;
        public bool? FilterIsLow
        {
            get { return mFilterIsLow; }
            set
            {
                mFilterIsLow = value;
                RaisePropertyChanged("FilterIsLow");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayIsLow = true;
        public bool IsDisplayIsLow
        {
            get { return mIsDisplayIsLow; }
            set
            {
                mIsDisplayIsLow = value;
                RaisePropertyChanged("IsDisplayIsLow");
                RaisePropertyChanged("HasFilter");
            }
        }

        private byte[] mFilterSpeed;
        public byte[] FilterSpeed
        {
            get { return mFilterSpeed; }
            set
            {
                mFilterSpeed = value;
                RaisePropertyChanged("FilterSpeed");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplaySpeed = true;
        public bool IsDisplaySpeed
        {
            get { return mIsDisplaySpeed; }
            set
            {
                mIsDisplaySpeed = value;
                RaisePropertyChanged("IsDisplaySpeed");
                RaisePropertyChanged("HasFilter");
            }
        }

        private byte[] mFilterNodeId;
        public byte[] FilterNodeId
        {
            get { return mFilterNodeId; }
            set
            {
                mFilterNodeId = value;
                RaisePropertyChanged("FilterNodeId");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayNodeId = true;
        public bool IsDisplayNodeId
        {
            get { return mIsDisplayNodeId; }
            set
            {
                mIsDisplayNodeId = value;
                RaisePropertyChanged("IsDisplayNodeId");
                RaisePropertyChanged("HasFilter");
            }
        }

        private byte[] mFilterSource;
        public byte[] FilterSource
        {
            get { return mFilterSource; }
            set
            {
                mFilterSource = value;
                RaisePropertyChanged("FilterSource");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplaySource = true;
        public bool IsDisplaySource
        {
            get { return mIsDisplaySource; }
            set
            {
                mIsDisplaySource = value;
                RaisePropertyChanged("IsDisplaySource");
                RaisePropertyChanged("HasFilter");
            }
        }

        private byte[] mFilterSourceHop;
        public byte[] FilterSourceHop
        {
            get { return mFilterSourceHop; }
            set
            {
                mFilterSourceHop = value;
                RaisePropertyChanged("FilterSourceHop");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplaySourceHop = true;
        public bool IsDisplaySourceHop
        {
            get { return mIsDisplaySourceHop; }
            set
            {
                mIsDisplaySourceHop = value;
                RaisePropertyChanged("IsDisplaySourceHop");
                RaisePropertyChanged("HasFilter");
            }
        }

        private byte[] mFilterDestinationHop;
        public byte[] FilterDestinationHop
        {
            get { return mFilterDestinationHop; }
            set
            {
                mFilterDestinationHop = value;
                RaisePropertyChanged("FilterDestinationHop");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayDestinationHop = true;
        public bool IsDisplayDestinationHop
        {
            get { return mIsDisplayDestinationHop; }
            set
            {
                mIsDisplayDestinationHop = value;
                RaisePropertyChanged("IsDisplayDestinationHop");
                RaisePropertyChanged("HasFilter");
            }
        }

        private byte[] mFilterDestination;
        public byte[] FilterDestination
        {
            get { return mFilterDestination; }
            set
            {
                mFilterDestination = value;
                RaisePropertyChanged("FilterDestination");
                RaisePropertyChanged("HasFilter");
            }
        }


        private bool mIsDisplayDestination = true;
        public bool IsDisplayDestination
        {
            get { return mIsDisplayDestination; }
            set
            {
                mIsDisplayDestination = value;
                RaisePropertyChanged("IsDisplayDestination");
                RaisePropertyChanged("HasFilter");
            }
        }

        private List<ByteIndex[]> mFilterHomeId;
        public List<ByteIndex[]> FilterHomeId
        {
            get { return mFilterHomeId; }
            set
            {
                mFilterHomeId = value;
                RaisePropertyChanged("FilterHomeId");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayHomeId = true;
        public bool IsDisplayHomeId
        {
            get { return mIsDisplayHomeId; }
            set
            {
                mIsDisplayHomeId = value;
                RaisePropertyChanged("IsDisplayHomeId");
                RaisePropertyChanged("HasFilter");
            }
        }

        private byte[] mFilterData;
        public byte[] FilterData
        {
            get { return mFilterData; }
            set
            {
                mFilterData = value;
                RaisePropertyChanged("FilterData");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayData = true;
        public bool IsDisplayData
        {
            get { return mIsDisplayData; }
            set
            {
                mIsDisplayData = value;
                RaisePropertyChanged("IsDisplayData");
                RaisePropertyChanged("HasFilter");
            }
        }

        private FilterPayloadObject mFilterPayload;
        public FilterPayloadObject FilterPayload
        {
            get { return mFilterPayload; }
            set
            {
                mFilterPayload = value;
                RaisePropertyChanged("FilterPayload");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayPayload = true;
        public bool IsDisplayPayload
        {
            get { return mIsDisplayPayload; }
            set
            {
                mIsDisplayPayload = value;
                RaisePropertyChanged("IsDisplayPayload");
                RaisePropertyChanged("HasFilter");
            }
        }

        private List<ByteIndex[]> mFilterHex;
        public List<ByteIndex[]> FilterHex
        {
            get { return mFilterHex; }
            set
            {
                mFilterHex = value;
                RaisePropertyChanged("FilterHex");
                RaisePropertyChanged("HasFilter");
            }
        }

        private bool mIsDisplayHex = true;
        public bool IsDisplayHex
        {
            get { return mIsDisplayHex; }
            set
            {
                mIsDisplayHex = value;
                RaisePropertyChanged("IsDisplayHex");
                RaisePropertyChanged("HasFilter");
            }
        }

        private static sbyte mFilterIdCounter = 1;
        private sbyte mFilterId = 1;

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        protected void RaisePropertyChanged(string propertyName)
        {
            if (propertyName != "HasFilter")
            {
                if (mFilterIdCounter == 127)
                {
                    mFilterIdCounter = 1;
                }
                else
                {
                    mFilterIdCounter++;
                }
                mFilterId = mFilterIdCounter;
                mFilteredCount = 0;
            }

            PropertyChangedEventHandler propertyChanged = this.PropertyChanged;
            if ((propertyChanged != null))
            {
                propertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

        #endregion


        public bool HasFilter
        {
            get
            {
                return FilterPayload != null ||
                FilterHex != null ||
                FilterData != null ||
                FilterDate1 != null ||
                FilterDate2 != null ||
                FilterDestination != null ||
                FilterHomeId != null ||
                FilterIsLow != null ||
                FilterSpeed != null ||
                FilterNodeId != null ||
                FilterSource != null ||
                FilterSourceHop != null ||
                FilterDestinationHop != null;
            }
        }

        public void Reset()
        {
            FilteredCount = 0;
            FilterPayload = null;
            FilterHex = null;
            FilterData = null;
            FilterDate1 = null;
            FilterDate2 = null;
            FilterDestination = null;
            FilterHomeId = null;
            FilterIsLow = null;
            FilterSpeed = null;
            FilterNodeId = null;
            FilterSource = null;
            FilterSourceHop = null;
            FilterDestinationHop = null;
        }

        public void FillFrom(FilterObject src)
        {
            Reset();
            if (src != null)
            {
                FilterPayload = src.FilterPayload;
                if (src.FilterHex != null && src.FilterHex.Count > 0)
                    FilterHex = src.FilterHex;
                if (src.FilterData != null && src.FilterData.Length > 0)
                    FilterData = src.FilterData;
                FilterDate1 = src.FilterDate1;
                FilterDate2 = src.FilterDate2;
                if (src.FilterDestination != null && src.FilterDestination.Length > 0)
                    FilterDestination = src.FilterDestination;
                if (src.FilterHomeId != null && src.FilterHomeId.Count > 0)
                    FilterHomeId = src.FilterHomeId;
                if (src.FilterNodeId != null && src.FilterNodeId.Length > 0)
                    FilterNodeId = src.FilterNodeId;
                if (src.FilterSource != null && src.FilterSource.Length > 0)
                    FilterSource = src.FilterSource;
                if (src.FilterSourceHop != null && src.FilterSourceHop.Length > 0)
                    FilterSourceHop = src.FilterSourceHop;
                if (src.FilterDestinationHop != null && src.FilterDestinationHop.Length > 0)
                    FilterDestinationHop = src.FilterDestinationHop;
                if (src.FilterIsLow != null)
                    FilterIsLow = src.FilterIsLow;
                if (src.FilterSpeed != null && src.FilterSpeed.Length > 0)
                    FilterSpeed = src.FilterSpeed;

                IsDisplayPayload = src.IsDisplayPayload;
                IsDisplayHex = src.IsDisplayHex;
                IsDisplayData = src.IsDisplayData;
                IsDisplayDate = src.IsDisplayDate;
                IsDisplayDestination = src.IsDisplayDestination;
                IsDisplayDestinationHop = src.IsDisplayDestinationHop;
                IsDisplayHomeId = src.IsDisplayHomeId;
                IsDisplayNodeId = src.IsDisplayNodeId;
                IsDisplaySource = src.IsDisplaySource;
                IsDisplaySourceHop = src.IsDisplaySourceHop;
                IsDisplaySpeed = src.IsDisplaySpeed;
            }
        }

        public bool FilterIt(DataItem ditem)
        {
            if (ditem == null)
            {
                return true;
            }

            if (ditem.CachedFilterStatus == mFilterId || ditem.CachedFilterStatus == -mFilterId)
            {
                return ditem.CachedFilterStatus > 0;
            }

            bool ret = true;
            {
                try
                {
                    ret = ApplyFilterState(ditem);
                }
                catch (Exception ex)
                {
                    ex.Message._EXLOG();
                }
            }
            if (ret)
            {
                FilteredCount++;
            }
            return ret;
        }

        protected virtual bool ApplyFilterState(DataItem ditem)
        {
            bool ret = true;
            DataItem zf = ditem;
            if (FilterDate1 != null && FilterDate2 != null)
            {
                if (zf.CreatedAt != null)
                {
                    ret &= (zf.CreatedAt >= FilterDate1) && (zf.CreatedAt <= FilterDate2);
                }
                else
                    ret = false;
            }

            if (ret && FilterIsLow != null)
            {
                ret = BoolFilterIt(zf.IsLow, IsDisplayIsLow, FilterIsLow);
            }

            if (ret && FilterSpeed != null)
            {
                ret = ValueFilterIt(zf.Speed, IsDisplaySpeed, FilterSpeed);
            }

            if (ret && FilterHex != null)
            {
                ret = ArrayFilterIt(zf.DataBuffer, IsDisplayHex, FilterHex);
            }

            if (ret && FilterNodeId != null)
            {
                if (zf.IsCrcOk && !zf.IsWakeupBeam && !zf.IsUnknownHeader)
                {
                    ret = ValueFilterIt(zf.Source, IsDisplayNodeId, FilterNodeId);
                    ret |= ValueFilterIt(zf.SrcHop, IsDisplayNodeId, FilterNodeId);
                    ret |= FilterDestinationInner(zf.Destination, IsDisplayNodeId, FilterNodeId);
                    ret |= ValueFilterIt(zf.DestHop, IsDisplayNodeId, FilterNodeId);
                }
                else
                    ret = false;
            }

            if (ret && FilterSource != null)
            {
                if (zf.IsCrcOk && !zf.IsWakeupBeam && !zf.IsUnknownHeader)
                    ret = ValueFilterIt(zf.Source, IsDisplaySource, FilterSource);
                else
                    ret = false;
            }

            if (ret && FilterSourceHop != null)
            {
                if (zf.IsCrcOk && !zf.IsWakeupBeam && !zf.IsUnknownHeader)
                    ret = ValueFilterIt(zf.SrcHop, IsDisplaySourceHop, FilterSourceHop);
                else
                    ret = false;
            }

            if (ret && FilterDestination != null)
            {
                if (zf.IsCrcOk && !zf.IsUnknownHeader)
                {
                    ret = FilterDestinationInner(zf.Destination, IsDisplayDestination, FilterDestination);
                }
                else
                    ret = false;
            }

            if (ret && FilterDestinationHop != null)
            {
                if (zf.IsCrcOk && !zf.IsWakeupBeam && !zf.IsUnknownHeader)
                    ret = ValueFilterIt(zf.DestHop, IsDisplayDestinationHop, FilterDestinationHop);
                else
                    ret = false;
            }

            if (ret && FilterHomeId != null)
            {
                if (zf.IsCrcOk && !zf.IsWakeupBeam && !zf.IsUnknownHeader)
                    ret = ArrayFilterIt(zf.HomeId, IsDisplayHomeId, FilterHomeId);
                else
                    ret = false;
            }

            if (ret && FilterData != null)
            {
                ret = ValueFilterIt(zf.HeaderType, IsDisplayData, FilterData);
            }

            if (ret && FilterPayload != null)
            {
                if (zf.IsCrcOk && !zf.IsWakeupBeam && !zf.IsUnknownHeader)
                {
                    bool passRes = false;
                    if (zf.CarryPayload != null)
                    {
                        CipherDataItem cipherBlock = new CipherDataItem();
                        if (FilterPayload.Indexes == null)
                        {
                            passRes = true;
                        }
                        else
                        {
                            foreach (var payload in zf.CarryPayload)
                            {
                                var res = ArrayFilterIt(payload, IsDisplayPayload, FilterPayload.Indexes);
                                if (!(IsDisplayPayload ^ res))
                                {
                                    passRes = res;
                                    break;
                                }
                                else
                                {
                                    passRes |= res;
                                }
                            }

                            if ((IsDisplayPayload ^ passRes))
                            {
                                cipherBlock = zf.Decrypt();
                                if (cipherBlock.IsDecrypted)
                                {
                                    passRes = ArrayFilterIt(cipherBlock.Payload, IsDisplayPayload, FilterPayload.Indexes);
                                }
                            }
                        }
                        if (passRes && FilterPayload.CipherExtensionType != null && IsDisplayPayload)
                        {
                            if (zf.GetCipherVersion() >= 0)
                            {
                                if (!cipherBlock.HasData)
                                {
                                    cipherBlock = zf.Decrypt();
                                }
                                if (cipherBlock.S2Extensions != null)
                                {
                                    if (FilterPayload.CipherExtensionEncrypted != null)
                                    {
                                        if ((bool)(FilterPayload.CipherExtensionEncrypted))
                                        {
                                            passRes = cipherBlock.S2Extensions.EncryptedExtensionsList.
                                          Where(x => (x.properties1.type == (byte)FilterPayload.CipherExtensionType) || (byte)FilterPayload.CipherExtensionType == 0x00).Any();
                                        }
                                        else
                                        {
                                            passRes = cipherBlock.S2Extensions.ExtensionsList.
                                              Where(x => (x.properties1.type == (byte)FilterPayload.CipherExtensionType) || (byte)FilterPayload.CipherExtensionType == 0x00).Any();
                                        }
                                    }
                                    else
                                    {
                                        passRes = cipherBlock.S2Extensions.ExtensionsList.Union(cipherBlock.S2Extensions.EncryptedExtensionsList).
                                            Where(x => (x.properties1.type == (byte)FilterPayload.CipherExtensionType) || (byte)FilterPayload.CipherExtensionType == 0x00).Any();
                                    }
                                }
                                else
                                {
                                    passRes = false;
                                }
                            }
                            else
                            {
                                passRes = false;
                            }
                        }
                    }
                    ret = passRes;
                }
                else
                    ret = false;
            }

            if (ret)
            {
                ditem.CachedFilterStatus = mFilterId;
            }
            else
            {
                ditem.CachedFilterStatus = (sbyte)-mFilterId;
            }

            return ret;
        }

        private bool FilterDestinationInner(byte[] destinations, bool isDisplayDestination, byte[] filterDestination)
        {
            bool ret = !isDisplayDestination;
            if (destinations != null)
            {
                bool result = false;
                foreach (var item in filterDestination)
                {
                    result = destinations.Contains(item);
                    if (result)
                        break;
                }
                ret = !(!result ^ !isDisplayDestination);
            }
            return ret;
        }

        private bool BoolFilterIt(bool data, bool isDisplay, bool? filter)
        {
            bool result = data == filter;
            return !(result ^ isDisplay);
        }

        private bool ValueFilterIt(byte data, bool isDisplay, byte[] filter)
        {
            bool result = filter.Contains(data);
            return !(result ^ isDisplay);
        }

        private bool ArrayFilterIt(byte[] data, bool isDisplay, List<ByteIndex[]> indexes)
        {
            bool ret = !isDisplay;
            if (data != null)
            {
                bool result = false;
                foreach (var item in indexes)
                {
                    for (int i = 0; i < item.Length; i++)
                    {
                        if (i < data.Length)
                        {
                            if (item[i].Presence == Presence.Value)
                            {
                                result = (data[i] & item[i].MaskInData) == item[i].Value;
                                if (!result)
                                {
                                    break;
                                }
                            }
                            else if (item[i].Presence == Presence.AnyValue)
                            {
                                result = true;
                            }
                        }
                        else
                        {
                            result = false;
                            break;
                        }
                    }
                    if (result)
                    {
                        ret = isDisplay;
                        break;
                    }
                }
            }
            return ret;
        }
    }

    public class FilterPayloadObject
    {
        public byte? CipherExtensionType { get; set; }
        public bool? CipherExtensionEncrypted { get; set; }
        public string SearchString { get; set; }
        public List<ByteIndex[]> Indexes { get; set; }
    }
}
