﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ZWaveController.ViewModels;
using ZWave.BasicApplication.Devices;
using ZWave.Devices;
using ZWave.CommandClasses;
using ZWave.BasicApplication.Operations;
using ZWave.Xml.Application;

namespace ZWaveController.Commands
{
    public abstract class AssociationCommandBase : CommandBasicBase
    {
        public AssociationModel AssociationModel
        {
            get { return (AssociationModel)ViewModel; }
        }

        public AssociationCommandBase(AssociationModel model)
            : base(model.MainVM, model)
        {
        }

        public override void UpdateTargetDevice()
        {
            if (AssociationModel.SelectedAssociativeDevice != null)
            {
                TargetDevice = AssociationModel.SelectedAssociativeDevice.Device;
                IsSleepingTarget = !MainVM.Controller.Network.IsDeviceListening(AssociationModel.SelectedAssociativeDevice.Device);
            }
            else if (AssociationModel.SelectedGroup != null)
            {
                TargetDevice = AssociationModel.SelectedGroup.ParentDevice.Device;
                IsSleepingTarget = !MainVM.Controller.Network.IsDeviceListening(AssociationModel.SelectedGroup.ParentDevice.Device);
            }
        }
    }
}
